<?php

  class sml_data_sources_xml_pathes extends mw_data{

    function init_source_xml_pathes(){
      $env = $this->env();
      $sources_dir = $env->path("content")."sources/";
      if(!is_dir($sources_dir)){
        if(file_exists($sources_dir)) return false;
        @mkdir($sources_dir);
      }
      if(!is_dir($sources_dir)) return false;
      $references_dir = $env->path("content")."sources/references/";
      if(!is_dir($references_dir)){
        if(file_exists($references_dir)) return false;
        @mkdir($references_dir);
      }
      if(!is_dir($references_dir)) return false;
      $derivations_dir = $env->path("content")."sources/derivations/";
      if(!is_dir($derivations_dir)){
        if(file_exists($derivations_dir)) return false;
        @mkdir($derivations_dir);
      }
      if(!is_dir($derivations_dir)) return false;
      return true;
    }

    function source_xml_path($id_source){
      if(!$this->init_source_xml_pathes()) return false;
      $env = $this->env();
      return $env->path("content")."sources/".$id_source.".xml";
    }

    function reference_edit_xml_dir_path(){
      if(!$this->init_source_xml_pathes()) return false;
      $env = $this->env();
      return $env->path("content")."sources/references/";
    }

    function reference_edit_xml_path($id_source){
      if(!$this->init_source_xml_pathes()) return false;
      $env = $this->env();
      return $this->reference_edit_xml_dir_path().$id_source.".xml";
    }

    function derivations_edit_xml_dir_path($id_source = null){
      if(!$this->init_source_xml_pathes()) return false;
      $env = $this->env();
      return $env->path("content")."sources/derivations/".(isset($id_source) ? $id_source."/" : "");
    }

    function derivation_edit_xml_path($id_source, $id_source_derivation){
      if(!$this->init_source_xml_pathes()) return false;
      $env = $this->env();
      return $this->derivations_edit_xml_dir_path($id_source).$id_source_derivation.".xml";
    }

    function source_xml_url($id_source){
      if(!$this->init_source_xml_pathes()) return false;
      $env = $this->env();
      return "http://".$_SERVER["SERVER_NAME"].$env->path("web").$this->source_xml_path($id_source);
    }

  }

?>